PrependTo[$Path, "../.."]

Needs["HEPMath`Symbolics`"]

Begin["`Test1`"]

y = 1

f1[0] = 1

f1[x_] := y*x + f1[x-1]

f2[x_] := x*f1[x]

End[]


testRename[] := Block[{tests={}},

  Rename[Global`Test1`f1, Global`Test2`f1, UpdateContexts->"Global`*"];
  Rename[Global`Test1`y, Global`Test2`y, UpdateContexts->"Global`*"];

  AppendTo[tests, (DownValues /. GetDefinition[Global`Test1`f2]) ===
    {HoldPattern[Global`Test1`f2[Global`Test1`x_]] :>
      Global`Test1`x*Global`Test2`f1[Global`Test1`x]}];
  AppendTo[tests, (DownValues /. GetDefinition[Global`Test2`f1]) ===
    {HoldPattern[Global`Test2`f1[0]] :> 1,
     HoldPattern[Global`Test2`f1[Global`Test1`x_]] :>
       Global`Test2`y*Global`Test1`x + Global`Test2`f1[Global`Test1`x - 1]}];
  AppendTo[tests, (OwnValues /. GetDefinition[Global`Test2`y]) ===
    {HoldPattern[Global`Test2`y] :> 1}];

  And@@tests
]

fail = False;

WriteString[$Output, "testRename:  "<>If[testRename[],"PASS\n", fail=True; "FAIL\n"]];

If[fail, Exit[1], Exit[]];


